import { Origami } from '.';
export declare type Routers = {
    [K in Origami.Server.Position]: RouterListItem[];
};
export interface RouterListItem {
    path: Origami.Server.URL;
    handlers: RouterUseHandler;
    method: Origami.Server.Method;
}
export declare type RouterUseHandler = (Origami.Server.RequestHandler | string)[];
export default class Route {
    parent?: Route;
    routers: Routers;
    nested: Route[];
    private _url;
    private _positions;
    private _activeRouter;
    private _curposition;
    constructor(url?: Origami.Server.URL, parent?: Route);
    private _position;
    readonly url: Origami.Server.URL;
    get(...handlers: RouterUseHandler): this;
    post(...handlers: RouterUseHandler): this;
    put(...handlers: RouterUseHandler): this;
    delete(...handlers: RouterUseHandler): this;
    all(...handlers: RouterUseHandler): this;
    use(...handlers: RouterUseHandler): this;
    position(position: Origami.Server.Position): this;
    route(path: Origami.Server.URL): Route;
    /**
     * Load all routers from a file or directory and nest them
     * @param path Path to file or directory
     * @param prefix Prefix the route
     * @param recursive If true, recursively nest routes
     */
    include(p: string, prefix?: string, r?: Boolean): Promise<number | false | undefined>;
    private _route;
}
