"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const bcrypt_1 = __importDefault(require("bcrypt"));
const jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
const SALT_ROUNDS = 10;
var auth;
(function (auth) {
    auth.hash = (pass) => bcrypt_1.default.hash(pass, SALT_ROUNDS);
    auth.compare = (pass, hash) => bcrypt_1.default.compare(pass, hash);
    auth.jwtSign = (data, secret) => jsonwebtoken_1.default.sign(data, secret, {
        expiresIn: '30m'
    });
    auth.jwtVerify = (token, secret) => jsonwebtoken_1.default.verify(token, secret);
})(auth = exports.auth || (exports.auth = {}));
