"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const log_symbols_1 = __importDefault(require("log-symbols"));
const _log = (type, object, ...rest) => {
    let icon = log_symbols_1.default.info;
    const obj = object ? `.${object}` : '';
    let color = 'magenta';
    switch (type) {
        case 'error':
            icon = log_symbols_1.default.error;
            color = 'red';
            break;
        case 'success':
            if (!process.env.LOG_VERBOSE)
                return;
            icon = log_symbols_1.default.success;
            color = 'green';
            break;
        case 'info':
            if (!process.env.LOG_VERBOSE)
                return;
            icon = log_symbols_1.default.info;
            color = 'blue';
            break;
        case 'warn':
            icon = log_symbols_1.default.warning;
            color = 'yellow';
            break;
    }
    console.log(icon, ` Origami${obj}:`[color], ...rest);
};
exports.success = (object, ...message) => _log('success', object, ...message);
exports.info = (object, ...message) => _log('info', object, ...message);
exports.log = (object, ...message) => _log('log', object, ...message);
exports.warn = (object, ...message) => _log('warn', object, ...message);
exports.error = (objOrError, error) => {
    if (objOrError instanceof Error)
        _log('error', objOrError.message.red);
    else if (error instanceof Error)
        _log('error', objOrError, error.message.red);
    else if (error)
        _log('error', objOrError, error.red);
};
