import { PackageJson } from './types';
export declare namespace pkgjson {
    /**
     * Attempt to load the package.json at the current directory
     * @returns {NPM.Static|Boolean} The package as json, or false if it cannot be found
     * or loaded correctly
    */
    const read: () => Promise<Boolean | PackageJson>;
    /**
     * Merge/create the package.json file
     * @param file JSON config for Origami app to override
     */
    const write: (file: PackageJson) => Promise<void>;
}
