"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require('path');
// @ts-ignore
const resolve_from_1 = __importDefault(require("resolve-from"));
const find_root_1 = __importDefault(require("find-root"));
/**
 * A fallback require function that attempts to load the library first from the
 * current workspace, then as a relative path, then as a module from where the
 * process is called
 */
exports.default = async (lib, context, prefix) => {
    // If trying to load a relative module
    if (lib.startsWith('/'))
        return lib;
    if (lib.startsWith('.'))
        return path.resolve(process.cwd(), lib);
    // Attempt to load module relative to where it's called with opt. prefix
    // EG: lib: user-profiles, prefix: origami-plugin-
    const p = resolve_from_1.default(find_root_1.default(context), `${prefix}${lib}`);
    if (p)
        return p;
    // Finally attempt to load it from the project's node_modules with opt. prefix
    return resolve_from_1.default(process.cwd(), `${prefix}${lib}`);
};
